'user strict';
var sql = require('./db');

// User object contructor
var User = function(user) {
    console.log(user);
    this.username = user.username;
    this.password = user.password;
    this.fullname = user.fullname;
    this.email = user.email;
    this.gender = user.gender;
    this.status = user.status;
    this.created_at = new Date();
};
// Tạo user mới
User.createUser = function createUser(newUser, result) {
    sql.query("INSERT INTO users set ?", newUser, function(err, res) {
        if(err) {
            console.log("error: ", err);
            result(err, null);
        }
        else {
            console.log(res.insertId);
            result(null, res.insertId);
        }
    });
};
// User theo Id
User.getUserById = function createUser(userId, result) {
    console.log(userId);
    sql.query("Select * from users where id = ?", userId, function(err, res) {
        if(err) {
            console.log("err: ", err);
            result(err, null);
        }
        else {
            result(null, res);
        }
    });
};
// List User
User.getAllUser = function getAllUser(result) {
    sql.query("Select * from users", function(err, res) {
        if(err) {
            console.log("error: ", err);
            result(null, err);
        }
        else {
            console.log('users: ', res);
            result(null, res);
        };
    });
};
// cập nhật user
User.updateById = function(id, user, result) {
    sql.query("UPDATE users SET username = ?, password = ?, email = ?, fullname = ?, gender = ?, updated_at = ? WHERE id = ?", [user.username, user.password, user.email, user.fullname, user.gender, new Date(), id], function (err, res) {
        if(err) {
            console.log("error: ", err);
            result(null, err);
        }
        else {
            result(null, res);
        };
    });
};
// Xóa user
User.remove = function(id, result) {
    sql.query("DELETE from users WHERE id = ?", [id], function (err, res) {
        if(err) {
            console.log("error: ", err);
            result(null, err);
        }
        else {
            result(null, res);
        }
    });
};

module.exports = User;